;*
;******************** DC,3  9 *************************************
;*
;*  ATtiny13A, RC- 9,6 
;*   - 37,5 
;*
;* Main:           
;*
;* TimerOFF:       ,  
;*
;* TIMER0_COMPA:    - 
;*
;* Fuses          CKSEL=10, SUT=10
;*                
;****************************************************************************

.nolist
.include "tn13def.inc"
.list

;***** *****

.def	t1	 = r16     ;   
.def	OutU = r17     ;    
.def	Cnt0 = r18     ;    0
.def	Cnt1 = r19     ;    1
.def	Cnt2 = r20     ;    2
.def	Cnt3 = r21     ;    3
.def	Comp = r22     ;              

;*****  *****

.equ  ConstU = 35  ;    ,  
.equ  Const0 = 255   ;  0   					  
.equ  Const1 = 255   ;  1   
.equ  Const2 = 255   ;  2   
.equ  Const3 = 2     ;  3   

.cseg

.org 0
	rjmp Initial		 ;  

.org 1					 ;  
    reti

.org 6
	rjmp TIMER0_COMPA    ;  A / T0


Initial: ;  
	
    ldi   t1,(RamEnd)
    out   spl,t1	    ;  
	
   	ldi	t1,0b00001010  
	out	PORTB,t1        ; PB0- ,PB1- SB1
	ldi	t1,0b00001001	; PB3-   VT2	
	out	DDRB,t1		     

clr Comp            ;    

ldi t1,1<<ADC2D
out DIDR0,t1        ;   

ldi Cnt0,Const0     ;    
ldi Cnt1,Const1     ; T.=0,0000266*(Const0*Const1*Const2*Const3)
ldi Cnt2,Const2
ldi Cnt3,Const3
sei                 ;  

Main:  ;  

ldi t1,0
out GIMSK,t1		 ;   

ldi OutU,ConstU
out  OCR0A,OutU 	 ;    T0

ldi t1,1<<ACBG
out ACSR,t1			;      AIN0 , 1,11V
ldi t1,1<<MUX1
out ADMUX,t1		;    , ADC2
ldi t1,1<<ACME
out ADCSRB,t1		;      AIN1 

ldi  t1,0            ;    T0
out  TCNT0,t1
ldi t1,(1<<COM0A1)|(1<<WGM01)|(1<<WGM00) ;   T0," "
out TCCR0A,t1
ldi t1,(1<<CS00)     ;     CK = 9,6 MHz
out TCCR0B,t1
ldi  t1,(1<<OCIE0A)
out  TIMSK0,t1       ;     T0
sbi PORTB,3          ;    VT2
clr R23      		 ;     
ldi R24,$A6          ;  0,5 , N=TF/5, T(), F()
ldi R25,$0E
Main0:               ;    
nop
cpi Comp,216	 	 ;   
breq Main1			 ;  ,   
sbic PINB,1			 ;   ,   SB1 
rjmp Main0           ;   
Main1:
subi R23,1			 ;   		 
sbci R24,0
sbci R25,0
brcc Main1
clr R23      		 ;     
ldi R24,$A6          ;  0,5 , N=TF/5, T(), F()
ldi R25,$0E
clr Comp			 ;  
cbi PORTB,3          ;    VT2

ldi t1,(1<<WGM01)|(1<<WGM00);   T0, OC0A   
out TCCR0A,t1
ldi t1,0 			 ;  
out TCCR0B,t1
ldi  t1,0
out  TIMSK0,t1       ;     T0
ldi t1,(1<<INT0)
out GIMSK,t1		 ;   

ldi t1,1<<ACD
out ACSR,t1			;  

ldi  t1,(1<<SE)|(1<<SM1);  "" , Power-Down
out  MCUCR,t1
sleep                ;   Power-Down
ldi  t1,(1<<SM1)     ;  "" , Power-Down
out  MCUCR,t1
Delay:			     ;   
subi R23,1		 
sbci R24,0
sbci R25,0
brcc Delay
rjmp Main

CONTR:;   

inc OutU		  ;  
out  OCR0A,OutU   ;    T0
rjmp CONTR0       ; 


TimerOFF: ;  ,    

dec Cnt0          ;  
brne TF0          ;   ,   
ldi Cnt0,Const0
dec Cnt1          ;  
brne TF0          ;   ,   
ldi Cnt1,Const1
dec Cnt2          ;  
brne TF0          ;   ,    
ldi Cnt2,Const2
dec Cnt3          ;  
brne TF0          ;   ,    
ldi Cnt0,Const0   ;    
ldi Cnt1,Const1
ldi Cnt2,Const2
ldi Cnt3,Const3
ldi Comp,216      ;     
ret
TF0:
ret

TIMER0_COMPA:  ;    T0

in    YL,ACSR	    ;    ACSR
sbrc  YL,ACO	    ;   ,     0
rjmp CONTR
CONTR0:

rcall TimerOFF      ;  ,  

reti

;*********************************************************************************
.Exit

